import { Buff, Bytes, Json } from '@cmdcode/buff-utils';
import { Cipher, SecretKey, PublicKey } from '@cmdcode/crypto-utils';
import { Token } from './token.js';
export type Payload = string | Json;
export interface EncodedData {
    data: string;
    token: Token;
}
export interface DecodedData {
    data: Payload;
    isValid: boolean;
}
export declare class CryptoSession {
    readonly _secret: Buff;
    readonly peerKey: Buff;
    static withToken(b64token: string, secretKey: Bytes): CryptoSession;
    constructor(peerKey: Bytes, secretKey: Bytes);
    get cipher(): Promise<Cipher>;
    get seckey(): SecretKey;
    get pubkey(): PublicKey;
    get shared(): Promise<Buff>;
    isWith(key: string): boolean;
    encrypt(data: Uint8Array): Promise<Uint8Array>;
    decrypt(data: Uint8Array): Promise<Uint8Array>;
    sign(payload: Bytes): Uint8Array;
    verify(token: string | Token, payload: Bytes): boolean;
    encode(payload: Payload): Promise<EncodedData>;
    decode(token: string | Token, payload: string): Promise<DecodedData>;
}
//# sourceMappingURL=session.d.ts.map